package de.cardcontact.opencard.eac.pkcs8;

import java.security.spec.ECField;
import java.security.spec.ECFieldFp;

import de.cardcontact.tlv.IntegerTLV;
import de.cardcontact.tlv.ObjectIdentifier;
import de.cardcontact.tlv.Sequence;
import de.cardcontact.tlv.TLV;
import de.cardcontact.tlv.TLVEncodingException;

public class FieldID extends Sequence {

	final static ObjectIdentifier ID_PRIME_FIELD = new ObjectIdentifier(new int[] { 1,2,840,10045,1,1 });
	final static String NAME = "FieldID";

	public FieldID(TLV tlv) throws TLVEncodingException {
		super(tlv);

		setName(NAME);

		if (childs.size() != 2) {
			throw new TLVEncodingException(NAME + " must contain 2 elements");
		}

		if (!childs.get(0).equals(ID_PRIME_FIELD)) {
			throw new TLVEncodingException("Unsupported field type");
		}

		if (!(childs.get(1) instanceof IntegerTLV)) {
			throw new TLVEncodingException("Field parameter must be INTEGER");
		}
	}



	public ECField getField() {
		return new ECFieldFp(((IntegerTLV)childs.get(1)).getBigInteger());
	}
}
